/*
    UPN-Calc - An arbitrary precision RPN calculator for J2ME/MIDP1
    Copyright (C) 2005 Kai G. Schwebke, upn.schwebke.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/*
 * Stack Data Structure
 */

class Stack
{

   private static final int MAX_STACK_SIZE = 50;
   private int stackSize;
   private final BCDFloat[] stack = new BCDFloat[MAX_STACK_SIZE];

   int prec;

   public Stack()
   {
      stackSize = 0;
      prec = 11;
   }

   public void clear()
   {
      stackSize = 0;
   }

   public int size()
   {
      return stackSize;
   }

   public BCDFloat at(int i)
   {
      return stack[i];
   }

   public BCDFloat top()
   {
      return at(stackSize-1);
   }

   public void push(BCDFloat f)
   {
      if (stackSize < (MAX_STACK_SIZE-1))
      {
	 f.prec = prec;
	 f.round();

	 stack[stackSize] = f;
	 ++stackSize;
      }
   }

   public void pop()
   {
      if (stackSize > 0)
      {
	 --stackSize;
	 stack[stackSize] = null;
      }
   }
   
}
